Happy Matt Friends HDU - 5119 (dp+滚动数组优化)

Matt has N friends. They are playing a game together.

Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins.

Matt wants to know the number of ways to win.
Input
The first line contains only one integer T , which indicates the number of test cases.

For each test case, the first line contains two integers N, M (1 ≤ N ≤ 40, 0 ≤ M ≤ 10^6).

In the second line, there are N integers ki (0 ≤ k i ≤ 10^6), indicating the i-th friend’s magic number.
Output
For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1) and y indicates the number of ways where Matt can win.
Sample Input
2
3 2
1 2 3
3 3
1 2 3
Sample Output
Case #1: 4
Case #2: 2

Hint
In the first sample, Matt can win by selecting:
friend with number 1 and friend with number 2. The xor sum is 3.
friend with number 1 and friend with number 3. The xor sum is 2.
friend with number 2. The xor sum is 2.
friend with number 3. The xor sum is 3. Hence, the answer is 4.

大致题意:有n个数,然后然你从中选一些出来将他们全部异或起来,所得到的值如果不小于m 则合法,问有多少种合法的选择方案,你可以一个都不选。

思路:假设dp[i][j]表示从前i个数中选择一些数异或起来结果为j的方案数。对于当前位置i上的数,我们有两种选择,选或者不选,所以状态转移方程为 dp[i][j]=dp[i-1][j^a[i]]+dp[i-1][j]。
然后这里我们还需用滚动数组来优化内存。

代码如下:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<queue>
#include<vector>
#include<cmath>
#include<string>
#define LL long long  
using namespace std;
LL dp[2][1<<21];
int a[45];
int main()
{
    int T;
    scanf("%d",&T);
    for(int cas=1;cas<=T;cas++)
    {
        int n,m;
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
        if(m==0)//如果为0,那么总的合法方案数即2^n
        {

            printf("Case #%d: %lld\n",cas,1<<n);
            continue;
        }
        memset(dp,0,sizeof(dp));

        dp[0][0]=1;
        for(int i=1;i<=n;i++)
        for(int j=0;j<(1<<21);j++)
        {
            dp[i&1][j]=dp[(i-1)&1][j]+dp[(i-1)&1][j^a[i]];
        }
        LL sum=0;
        for(int i=m;i<(1<<21);i++)
        sum+=dp[n&1][i];
        printf("Case #%d: %lld\n",cas,sum);
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值